//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37FDFDFFAD90.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37FDFDFFAD90.cm

//## begin module%37FDFDFFAD90.cp preserve=no
//## end module%37FDFDFFAD90.cp

//## Module: RealResponse%37FDFDFFAD90; Package body
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/Detector/RealResponse.cxx

//## begin module%37FDFDFFAD90.additionalIncludes preserve=no
//## end module%37FDFDFFAD90.additionalIncludes

//## begin module%37FDFDFFAD90.includes preserve=yes
//## end module%37FDFDFFAD90.includes

// Model
#include <XSModel/Model/Model.h>
// SumComponent
#include <XSModel/Model/Component/SumComponent.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
// RealResponse
#include <XSModel/Data/Detector/RealResponse.h>
//## begin module%37FDFDFFAD90.declarations preserve=no
//## end module%37FDFDFFAD90.declarations

//## begin module%37FDFDFFAD90.additionalDeclarations preserve=yes
#include <XSContainer.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/Parameter/ResponseParam.h>
#include <GlobalContainer/ResponseContainer.h>
#include <Data/BackCorr/Background.h>
#include <XSUtil/Numerics/LinearInterp.h>
#include <XSstreams.h>
#include <iostream>
#include <cstring>
//## end module%37FDFDFFAD90.additionalDeclarations


// Class RealResponse 

RealResponse::RealResponse()
  //## begin RealResponse::RealResponse%37FDF6AF1F30_const.hasinit preserve=yes
      : Response(),
        m_rmfName(""), 
	m_arfName(""),
	m_arfRow(0),
        m_savedEffectiveArea(),  
        m_effectiveArea(),
        m_rmfData(0),
        m_source(0),
	m_noticedElements(),
	m_noticedElemPos()
  //## end RealResponse::RealResponse%37FDF6AF1F30_const.hasinit
  //## begin RealResponse::RealResponse%37FDF6AF1F30_const.initialization preserve=yes
  //## end RealResponse::RealResponse%37FDF6AF1F30_const.initialization
{
  //## begin RealResponse::RealResponse%37FDF6AF1F30_const.body preserve=yes
  //## end RealResponse::RealResponse%37FDF6AF1F30_const.body
}

RealResponse::RealResponse(const RealResponse &right)
  //## begin RealResponse::RealResponse%37FDF6AF1F30_copy.hasinit preserve=yes
      : Response(right), 
        m_rmfName(right.m_rmfName),
	m_arfName(right.m_arfName), 
	m_arfRow(right.m_arfRow),
        m_savedEffectiveArea(right.m_savedEffectiveArea),
        m_effectiveArea(right.m_effectiveArea),
        m_rmfData(right.m_rmfData), // refcounted: let copy constructor RMF worry about memory
        m_source(right.m_source),
	m_noticedElements(right.m_noticedElements),
	m_noticedElemPos(right.m_noticedElemPos)
  //## end RealResponse::RealResponse%37FDF6AF1F30_copy.hasinit
  //## begin RealResponse::RealResponse%37FDF6AF1F30_copy.initialization preserve=yes
  //## end RealResponse::RealResponse%37FDF6AF1F30_copy.initialization
{
  //## begin RealResponse::RealResponse%37FDF6AF1F30_copy.body preserve=yes
  //## end RealResponse::RealResponse%37FDF6AF1F30_copy.body
}


RealResponse::~RealResponse()
{
  //## begin RealResponse::~RealResponse%37FDF6AF1F30_dest.body preserve=yes
  checkRMFdata();      
  //## end RealResponse::~RealResponse%37FDF6AF1F30_dest.body
}


RealResponse & RealResponse::operator=(const RealResponse &right)
{
  //## begin RealResponse::operator=%37FDF6AF1F30_assign.body preserve=yes
  if (this != &right) copy(right);
  return *this;
  //## end RealResponse::operator=%37FDF6AF1F30_assign.body
}



//## Other Operations (implementation)
Model& RealResponse::operator * (Model& model) const
{
  //## begin RealResponse::operator*%37FE06C538C0.body preserve=yes
   // multiply the model photon array with the sparse representation
   // of the response matrix, taking into account its representation
   // as a set of row-wise run starting at point {binStartChannels[i]}
   // and continuing for length {binRunLengths[i]}
    
   // get reference to appropriate arrays.   
    
//        RealArray S(numChannels(),0);
   int iData(spectrumNumber());
      
   const RealArray& modFlux = model.modelFlux(iData);
   RealArray foldedMod(numChannels());
   if ( modFlux.size())
   {
           const RealArray& modFluxErr = model.modelFluxError(iData);
           RealArray foldedModErr;
           if (modFluxErr.size()) foldedModErr.resize(numChannels());
           convolve(modFlux,modFluxErr,foldedMod,foldedModErr);

// Can't have multiple threads trying to insert arrays into the
// same Model object.  That would cause a race condition.
#pragma omp critical
          {
           model.foldedModel(iData,foldedMod);
           if (modFluxErr.size()) model.foldedModelError(iData,foldedModErr);
          }
   }    
   else
   {
#pragma omp critical
          {
           model.foldedModel(iData,foldedMod);
           model.foldedModelError(iData,RealArray());
          }           
   }           
   return model;
  //## end RealResponse::operator*%37FE06C538C0.body
}

void RealResponse::setData (size_t specNum, size_t groupNumber, size_t nRmf)
{
  //## begin RealResponse::setData%3A3A78170361.body preserve=yes
  
  using namespace XSContainer;
  
  // Since an extension specifier is optional for the first response extension
  // (extVer = 1), must treat cases such as myResp.rsp and myResp.rsp{1} as the
  // same RMF.  
  string secondTest;
  string::size_type extLoc = string::npos;
  if (m_rmfName.find_first_of('{') == string::npos)
     secondTest = m_rmfName + "{1}";
  else if ((extLoc = m_rmfName.find("{1}")) != string::npos)
     secondTest = m_rmfName.substr(0,extLoc);
  
  
  bool readRMF(true);
  std::pair<RMFMapConstIter,RMFMapConstIter> range(responses->RMFmap().equal_range(m_rmfName));
  if (range.first == range.second && secondTest.length())
     range = responses->RMFmap().equal_range(secondTest);
  const SpectralData* spec = source();
  int firstChan = static_cast<int>(spec->firstChan());
  int startChan = static_cast<int>(spec->startChan());
  int endChan = static_cast<int>(spec->endChan());
  RMFMapConstIter p(range.first);
  while (readRMF && p != range.second) 
  {
	const CodeContainer& w = m_source->gqString();
  	if (p->second->compareChanRange(firstChan, startChan, endChan) 
                && p->second->gqMatch(w))
	{
		readRMF = false;
	}

	else
	{
		++p;
	}
  }
  
  if (!readRMF)
  {
  	rmfData(p->second);
	setSharedDescription(specNum, groupNumber);	
  }
  
  else
  {
  	read(m_rmfName);
  	setArrays();          
  	setDescription(specNum,groupNumber);
	responses->addToList(RefCountPtr<RMF>(m_rmfData)); 
	closeSourceFiles();
  }
  
  //## end RealResponse::setData%3A3A78170361.body
}

bool RealResponse::readAuxResponse (int rowNum)
{
  //## begin RealResponse::readAuxResponse%3A758B6303DC.body preserve=yes
  return false;
  //## end RealResponse::readAuxResponse%3A758B6303DC.body
}

void RealResponse::Swap (RealResponse& right) throw ()
{
  //## begin RealResponse::Swap%3A956ADB00C0.body preserve=yes
  gSwap(*this,right);
  std::swap(m_effectiveArea,right.m_effectiveArea);
  std::swap(m_rmfData,right.m_rmfData);
  std::swap(m_source,right.m_source); 
  std::swap(m_rmfName,right.m_rmfName);
  std::swap(m_arfName,right.m_arfName);
  std::swap(m_arfRow,right.m_arfRow);
  std::swap(m_savedEffectiveArea,right.m_savedEffectiveArea);
  std::swap(m_noticedElements,right.m_noticedElements);
  std::swap(m_noticedElemPos,right.m_noticedElemPos);

  //## end RealResponse::Swap%3A956ADB00C0.body
}

void RealResponse::setEnergies ()
{
  //## begin RealResponse::setEnergies%3AC4BC6C02B3.body preserve=yes
  energies().resize(numEnergies()+1);
  
  energies(0,m_rmfData->energyLow(0));
  for (size_t j = 0; j < numEnergies(); ++j)
  {
        energies(j+1,m_rmfData->energyHigh(j));
  }
  
  //## end RealResponse::setEnergies%3AC4BC6C02B3.body
}

void RealResponse::setSharedDescription (size_t specNum, size_t groupNum)
{
  //## begin RealResponse::setSharedDescription%3ACA1F460279.body preserve=yes
  numChannels(m_rmfData->eboundsMin().size());
  numEnergies(m_rmfData->energyLow().size());
        
  dataGroup(groupNum);
  spectrumNumber(specNum);
  setEffectiveArea(m_rmfData->normFactor());
  if (m_arfName.length())
  {     
     readAuxResponse();
  }
  const string fakeitPlaceholder("USE_FAKEIT_RMF");
  const string& rmfTelescope = m_rmfData->telescope();
  const string& rmfInstrument = m_rmfData->instrument();
  const string& rmfChanType = m_rmfData->channelType();
  
  if (m_source->telescope() == fakeitPlaceholder)
  {
     if (rmfTelescope.size())
        m_source->telescope(rmfTelescope);
     else
        m_source->telescope("UNKNOWN");
  }
  else if (rmfTelescope != m_source->telescope())
     tcout << "Warning: RMF TELESCOPE keyword is not consistent with spectrum" <<std::endl;

  if (m_source->instrument() == fakeitPlaceholder)
  {
     if (rmfInstrument.size())
        m_source->instrument(rmfInstrument);
     else
        m_source->instrument("UNKNOWN");
  }
  else if (rmfInstrument != m_source->instrument())
     tcout << "Warning: RMF INSTRUMENT keyword is not consistent with spectrum" <<std::endl;
     
  if (m_source->channelType() == fakeitPlaceholder)
  {
     m_source->channelType(rmfChanType);
  }
  else
  {
     const string& specChanStr = m_source->channelType(); 
     if (rmfChanType.length() && rmfChanType != specChanStr)
     {
       tcout << "Warning: RMF CHANTYPE keyword (" << rmfChanType
	     << ") is not consistent with that from spectrum (" 
	     << specChanStr << ")" <<std::endl;        
     }
  }
  //## end RealResponse::setSharedDescription%3ACA1F460279.body
}

void RealResponse::RMFremove ()
{
  //## begin RealResponse::RMFremove%3B9013250238.body preserve=yes
  if (m_rmfData.operator->() && m_rmfData->refCount() == 2)      
  {      
        XSContainer::responses->removeByToken(m_rmfData);      
  }
  //## end RealResponse::RMFremove%3B9013250238.body
}

bool RealResponse::order (const Response& right) const
{
  //## begin RealResponse::order%3B94E93900B8.body preserve=yes
  const RealResponse& that = static_cast<const RealResponse&>(right);
  bool result (false);
  if (m_rmfName < that.m_rmfName)
  {
        result = true;
  }
  else 
  {
        if (m_rmfName == that.m_rmfName && index() < that.index()) result = true;       
  }
  return result;
  //## end RealResponse::order%3B94E93900B8.body
}

const RealArray& RealResponse::eboundsMin () const
{
  //## begin RealResponse::eboundsMin%3BDDBE420342.body preserve=yes
  return m_rmfData->eboundsMin();
  //## end RealResponse::eboundsMin%3BDDBE420342.body
}

const RealArray& RealResponse::eboundsMax () const
{
  //## begin RealResponse::eboundsMax%3BDDBE70004B.body preserve=yes
  return m_rmfData->eboundsMax();
  //## end RealResponse::eboundsMax%3BDDBE70004B.body
}

void RealResponse::convolve (const RealArray& flux, const RealArray& fluxErr, RealArray& foldFlux, RealArray& foldFluxErr) const
{
  //## begin RealResponse::convolve%3C3F14DC0199.body preserve=yes
   const IntegerArray& firstEngs = m_rmfData->energyStart();
   const IntegerArray& numbInGroup = m_rmfData->energyRunLengths();
   const IntegerArray& chanForRun = m_rmfData->channelForRun();
   Real* convArray(m_rmfData->convArray());
   
   RealArray aflux (m_effectiveArea*flux);
   XSutility::auto_array_ptr<Real> pAflux (new Real[aflux.size()]);
   Real* Aflux (pAflux.get());
   std::copy(&aflux[0],&aflux[0]+aflux.size(),&Aflux[0]);
   
   const size_t N (numChannels());
   
   XSutility::auto_array_ptr<Real> pFoldFlux(new Real[numChannels()]);
   Real* FoldFlux (pFoldFlux.get());
   memset(FoldFlux,0,N*sizeof(Real));
   	   
   size_t firstEng_i (0);
   size_t chanForRun_i (0);
   Real foldFlux_i (0);
   Real foldFluxErr_i (0);
   Real cnv_j (0);
   
   size_t noticedElements_i(0);
   size_t noticedSz = m_noticedElements.size();
   
   if (fluxErr.size())
   {	
   	RealArray fluxVariance(m_effectiveArea*fluxErr*fluxErr);
        XSutility::auto_array_ptr<Real> pFluxVariance (new Real[fluxVariance.size()]);
        Real* FluxVariance (pFluxVariance.get());
        std::copy(&fluxVariance[0],&fluxVariance[0]+fluxVariance.size(),&FluxVariance[0]);
        
        XSutility::auto_array_ptr<Real> pFoldFluxErr(new Real[numChannels()]);
        Real* FoldFluxErr (pFoldFluxErr.get());
        memset(FoldFluxErr,0,N*sizeof(Real));
               
	for (size_t i=0; i<noticedSz; ++i)
	{
	   noticedElements_i = m_noticedElements[i];
	   chanForRun_i = chanForRun[noticedElements_i]; 
	   firstEng_i = firstEngs[noticedElements_i]; 
	   foldFlux_i = FoldFlux[chanForRun_i];
	   foldFluxErr_i = FoldFluxErr[chanForRun_i];
           
           size_t fm (firstEng_i +numbInGroup[noticedElements_i]);
           size_t jj (m_noticedElemPos[i]);
           
	   for (size_t j = firstEng_i; j < fm; ++j)
	   {
	      cnv_j = convArray[jj];
	      foldFlux_i += Aflux[j]*cnv_j;
	      foldFluxErr_i += FluxVariance[j]*cnv_j;
              ++jj;
	   }
	   FoldFlux[chanForRun_i] = foldFlux_i;
	   FoldFluxErr[chanForRun_i] = foldFluxErr_i;
	}  
        foldFlux = RealArray(FoldFlux,N);
        foldFluxErr = RealArray(FoldFluxErr,N);
        
   }
   else
   {
        Real ac(0);
	for (size_t i=0; i<noticedSz; ++i)
	{
	   noticedElements_i = m_noticedElements[i];
	   chanForRun_i = chanForRun[noticedElements_i];
	   firstEng_i = firstEngs[noticedElements_i]; 
	   foldFlux_i = FoldFlux[chanForRun_i];
           size_t fm (firstEng_i +numbInGroup[noticedElements_i]);
           size_t jj (m_noticedElemPos[i]);
	   for (size_t j = firstEng_i; j < fm; ++j)
           {
              ac = Aflux[j];
              ac *= convArray[jj];
	      foldFlux_i += ac;
//              ++jj,++x;
              ++jj;

           }
	   FoldFlux[chanForRun_i] = foldFlux_i;
	}
        foldFlux = RealArray(FoldFlux,N);
   } 
//   tcout << " lp= " << x << std::endl;
  //## end RealResponse::convolve%3C3F14DC0199.body
}

void RealResponse::prepareForFit ()
{
  //## begin RealResponse::prepareForFit%3C3F15A703AB.body preserve=yes
   size_t k=0;
   // ChanForRun, numbInGroup, and firstEngs are all the same length,
   // = # of channel row groups.  
   const IntegerArray& chanForRun = m_rmfData->channelForRun();
   const IntegerArray& numbInGroup = m_rmfData->energyRunLengths();
   const size_t N (chanForRun.size());
   size_t offset = source()->startChan() - source()->firstChan();
   m_noticedElements.clear();
   m_noticedElemPos.clear();
   m_noticedElements.reserve(N);
   m_noticedElemPos.reserve(N);
   for (size_t i=0; i < N ; i++)
   {
      if (m_source->noticedChannels()[chanForRun[i]+offset])
      {
         m_noticedElements.push_back(i);
	 m_noticedElemPos.push_back(k);
      }
      k += numbInGroup[i];
   }
  //## end RealResponse::prepareForFit%3C3F15A703AB.body
}

const RealArray& RealResponse::efficiency () const
{
  //## begin RealResponse::efficiency%3CF6341B020A.body preserve=yes
  return m_effectiveArea;
  //## end RealResponse::efficiency%3CF6341B020A.body
}

RealArray RealResponse::sensitivity (const SpectralData* data)
{
  //## begin RealResponse::sensitivity%3DE51AE903B2.body preserve=yes
        
  // computes the vector which is the sum of Response / Data variance at
  // each channel.      
        
  size_t nz = m_noticedElements.size();
  const IntegerArray& chanForRun    = m_rmfData->channelForRun();
  const IntegerArray& firstEnergy   = m_rmfData->energyStart();
  const IntegerArray& numberInGroup = m_rmfData->energyRunLengths();
  Real* convArray(m_rmfData->convArray());
  RealArray sens(0.,numEnergies());
  RealArray effAreaSq (m_effectiveArea*m_effectiveArea);
  Real ac(0),respElt(0);
  size_t ne(0), ch(0), first(0), last(0), jpos(0);
  for (size_t j = 0; j < nz; ++j)
  {
        ne = m_noticedElements[j];
        ch = chanForRun[ne];
        first =  firstEnergy[ne];
        last  = first + numberInGroup[ne];
        jpos  = m_noticedElemPos[j];
        Real var = data->variance(ch);
        if (data->background())
           var += data->background()->variance()[ch];
        for (size_t k = first; k < last; ++k )
        {
                respElt = convArray[jpos];
                ac =  effAreaSq[k]*respElt*respElt;
                sens[k] += ac/var;
                ++jpos;
        } 
  }
  
  
  return sens;
  //## end RealResponse::sensitivity%3DE51AE903B2.body
}

void RealResponse::operator * (SumComponent& source) const
{
  //## begin RealResponse::operator*%3DE7CE3D02B6.body preserve=yes
   int iData(spectrumNumber());
  // one of those rare uses for const_cast which seem to be acceptable.
  // source is cast to const so it can call the const versions of
  // photonArray(), etc ... the non-const versions are protected.
   const SumComponent& csource = const_cast<SumComponent&>(source);      
   const RealArray& photonFlux = csource.photonArray(iData);
   source.foldedPhotonFlux(iData).resize(numChannels(),0.);
   if ( csource.photonErrArray(iData).size())  
   {
           source.foldedPhotonFluxErr(iData).resize(numChannels(),0.);
   }
   convolve(photonFlux,csource.photonErrArray(iData),source.foldedPhotonFlux(iData),
                             source.foldedPhotonFluxErr(iData));
 
  //## end RealResponse::operator*%3DE7CE3D02B6.body
}

void RealResponse::shiftEffectiveArea (const RealArray& newEnergies)
{
  //## begin RealResponse::shiftEffectiveArea%4140791503D6.body preserve=yes
  const Real FUZZY = 1.0e-6;
  // Lazy initialization of m_savedEffectiveArea array. If gain
  // command is never called, this need not be done.
  if (!m_savedEffectiveArea.size())
  {
     m_savedEffectiveArea.resize(m_effectiveArea.size());
     m_savedEffectiveArea = m_effectiveArea;
  }
  size_t inStart, outStart;
  if (!Numerics::Rebin::findFirstBins(energies(), newEnergies, FUZZY,
                inStart, outStart))
  {
     string msg("***No new energy bins overlap the old, cannot apply gain.");
     throw GainError(msg);
  }
  IntegerArray startBin, endBin;
  RealArray startWeight, endWeight;
  Numerics::Rebin::initializeBins(newEnergies, energies(), FUZZY, inStart,
                outStart, startBin, endBin, startWeight, endWeight);
  // this function modifies m_effectiveArea
  Numerics::Rebin::gainRebin(m_savedEffectiveArea, startBin, endBin, 
                startWeight, endWeight, m_effectiveArea);
  //## end RealResponse::shiftEffectiveArea%4140791503D6.body
}

void RealResponse::restoreEffectiveArea ()
{
  //## begin RealResponse::restoreEffectiveArea%414092A20018.body preserve=yes
  size_t sz = m_savedEffectiveArea.size();
  if (sz)
  {
     if (m_effectiveArea.size() == sz)
     {
        m_effectiveArea = m_savedEffectiveArea;
     }
     else
     {
        throw RedAlert("Size mismatch between old and new effectiveArea array.");
     }
  }
  
  //## end RealResponse::restoreEffectiveArea%414092A20018.body
}

void RealResponse::makeDerivative (Real delta, RealArray& deriv, Response::ResponseParType parType)
{
  //## begin RealResponse::makeDerivative%415B0EC403B3.body preserve=yes
  Model* mod = XSContainer::models->lookup(this);
  if (!mod)
  {
     std::ostringstream os;
     os << "***Cannot fit gain parameters to response for spectrum "
        << spectrumNumber() << " source " << sourceNumber()
        << ",\n     as it has no model assigned to it." << std::endl;
     throw Response::GainError(os.str());
  }
//  deriv.resize(numChannels(),.0);
  ResponseParam* pGain = (parType == LINEAR) ? linearGain() : constGain();
  // Assume pGain exists or we couldn't have gotten here.
  
  RealArray deltaArea(.0, m_effectiveArea.size());
  Real val = pGain->value('a');
  pGain->setValue(val + delta, 'a');
  deltaArea = m_effectiveArea;
  pGain->setValue(val - delta, 'a');
  deltaArea -= m_effectiveArea;
  pGain->setValue(val, 'a');
  // Note: Can't use m_savedEffectiveArea as that is for NO gain
  // applied.  We want to save the values for gain=val applied.
  RealArray saveEffectiveArea(m_effectiveArea);
  m_effectiveArea = deltaArea;
  (*this)*(*mod);
  // mod's folded flag should still be 'false'.  We don't
  // set it to 'true' since it contains the folded values
  // for this temporary m_effectiveArea.
  const RealArray& folded = mod->foldedModel(spectrumNumber());
  const std::valarray<size_t>& IN = m_source->indirectNotice();
  deriv.resize(IN.size(), .0);
  deriv = folded[IN];
  deriv /= 2.0*delta;
  m_effectiveArea = saveEffectiveArea;
  //## end RealResponse::makeDerivative%415B0EC403B3.body
}

void RealResponse::calcEffAreaPerChan (RealArray& effArea)
{
  //## begin RealResponse::calcEffAreaPerChan%42136C2E0080.body preserve=yes
   // Can't assume prepareForFit was called.  There may be no model
   // associated with this response.
   prepareForFit();
   const RealArray& ebins = energies();
   const size_t nBins = ebins.size()-1;
   RealArray dummyError;
   effArea.resize(numChannels(), .0);
   // flatFlux corresponds to a constant rate/keV.  Therefore the flux
   // in each bin is proportional to the bin width.
   RealArray flatFlux(.0, nBins);
   Real lowerE = ebins[0];
   for (size_t i=0; i<nBins; ++i)
   {
      Real higherE = ebins[i+1];
      flatFlux[i] = higherE - lowerE;
      lowerE = higherE;
   }
   convolve(flatFlux, dummyError, effArea, dummyError);
   
   const RealArray& chanEmin = eboundsMin();
   const RealArray& chanEmax = eboundsMax();
   const size_t nChans = chanEmin.size();
   RealArray chanWidths(.0, nChans);
   if (nChans != effArea.size())
   {
      throw RedAlert("Channel size mismatch in RealResponse::calcEffAreaPerChan");
   }
   chanWidths = chanEmax - chanEmin;
   effArea /= chanWidths;
  //## end RealResponse::calcEffAreaPerChan%42136C2E0080.body
}

void RealResponse::setZeroGainEffectiveArea (const RealArray& newEffArea)
{
  //## begin RealResponse::setZeroGainEffectiveArea%4A0C87750331.body preserve=yes
   if (m_savedEffectiveArea.size())
   {
      if (m_savedEffectiveArea.size() != newEffArea.size())
      {
         throw RedAlert("Size mismatch between old and new effective area array.");
      }
      m_savedEffectiveArea = newEffArea;
   }
  //## end RealResponse::setZeroGainEffectiveArea%4A0C87750331.body
}

// Additional Declarations
  //## begin RealResponse%37FDF6AF1F30.declarations preserve=yes
  //## end RealResponse%37FDF6AF1F30.declarations

//## begin module%37FDFDFFAD90.epilog preserve=yes
//## end module%37FDFDFFAD90.epilog
